#include "cpp.c"
#include "python.c"

void libc_start_main(int (*main)(int argc, char** argv, char** envp), int argc, char** ubp_av,
                       void (*init)(), void (*fini)(), void (*rtld_fini)(), void* stack_end) __noreturn;
void uClibc_main(int (*main)(int argc, char** argv, char** envp), int argc,
                   char** argv, void (*init)(void), void (*fini)(void),
                   void (*rtld_fini)(void), void *stack_end) __noreturn;

// Linux Standards Base
void Unwind_Resume(void* exception_object) __noreturn;
void Unwind_Resume_or_Rethrow(void* exception_object) __noreturn;
void Unwind_SjLj_Resume(void* exception_object) __noreturn;
void Unwind_SjLj_Resume_or_Rethrow(void* exception_object) __noreturn;
void Unwind_RaiseException() __noreturn;
void assert_fail(const char* assertion, const char* file, unsigned int line, const char* function) __noreturn;

// GLIBC
void fortify_fail(const char *msg) __noreturn;
void fortify_fail_abort(bool need_backtrace, const char *msg) __noreturn;
void libc_fatal (const char *__message) __noreturn;
void chk_fail (void) __noreturn;
void exit_thread(void) __noreturn;
void support_exit_failure_impl (int exit_status, const char *file, int line, const char *format , va_list args) __noreturn;
void support_test_verify_exit_impl(int status, const char *file, int line, const char *expr) __noreturn;
void libc_unwind_longjmp(void* env, int val) __noreturn;
void sigstack_longjmp (void* env, int val) __noreturn;
void termination_handler(int signum) __noreturn;
void good_bye(void) __noreturn;
void libc_main(void) __noreturn;
void start_thread(void) __noreturn;
void dl_start(void) __noreturn;
void panic(const char* fmt, va_list args) __noreturn;
int reboot(int cmd) __noreturn;

// These noreturn functions where found looking at ubuntu 18.04 lib directory
void BZ2_bz__AssertH__fail(int errcode) __noreturn;
void assert_perror_fail(int	errnum, const char* file, uint line, const char* func) __noreturn;
void basic_exit_err(int status, const char *msg, ...) __noreturn;
void clean_exit(void* request) __noreturn;
void condvar_cleanup1() __noreturn;
void condvar_cleanup2() __noreturn;
void dbus_exit() __noreturn;
void gcry_sexp_alist(const void** a) __noreturn;
void gcry_sexp_append(const void* a, const void* b) __noreturn;
void gcry_sexp_cons(const void* a, const void* b) __noreturn;
void gcry_sexp_prepend(const void* a, const void* b) __noreturn;
void gcry_sexp_vlist(int a, const char* msg) __noreturn;
void isc_assertion_failed(const char * file, int line, int type, const char * cond) __noreturn;
void isc_error_fatal(const char *file, int line, const char *format,...) __noreturn;
void isc_error_runtimecheck(const char *file, int line, const char *expression) __noreturn;
void lh_abort() __noreturn;
void libc_longjmp(void* env, int val) __noreturn;
void mc_abort(const char *msg,...) __noreturn;
void nc_err_abort() __noreturn;
void nc_free_and_exit(void* screen, int msg) __noreturn;
void nc_syserr_abort() __noreturn;
void nptl_main() __noreturn;
void ped_assert(int cond, const char* cond_text, const char* file, int line, const char* function) __noreturn;
void png_chunk_error(void* png_ptr, const char* msg) __noreturn;
void png_error(void* png_ptr, const char* msg) __noreturn;
void pthread_exit_0() __noreturn;
void pthread_unwind_0() __noreturn;
void pthread_unwind_next_0() __noreturn;
void rl_abort(int arg1, int arg2) __noreturn;
void rl_abort_internal() __noreturn;
void ss_page_stdin() __noreturn;
void tcpd_jump(const char* fmt, ...) __noreturn;
void unwind_cleanup(int reason, void* exc) __noreturn;
void xalloc_die() __noreturn;
void xstrtol_fatal(int err, int opt_idx, char c, void* options, char const *arg) __noreturn;