#include "python.c"
#include "cpp.c"

// arch specific file must provide ULONG_PTR, LONG_PTR, DWORD_PTR, UINT_PTR, SIZE_T
/*
typedef void* LONG_PTR;
typedef void* ULONG_PTR;
typedef void* DWORD_PTR;
typedef void* UINT_PTR;
typedef void* SIZE_T;
*/

typedef SIZE_T* PSIZE_T;
typedef ULONG_PTR* PULONG_PTR;

typedef char* va_list;

typedef LONG_PTR LPARAM;
typedef LONG_PTR LRESULT;

typedef void* HANDLE;
typedef HANDLE* PHANDLE;
typedef HANDLE* LPHANDLE;

typedef HANDLE HGLOBAL;

typedef void* PVOID;
typedef void* LPVOID;
typedef const void* LPCVOID;

typedef uint8_t BYTE;
typedef uint8_t* PBYTE;
typedef uint8_t* LPBYTE;

typedef BYTE BOOLEAN;
typedef BYTE* PBOOLEAN;

typedef char CHAR;
typedef char* PCHAR;
typedef char* PCH;
typedef char* LPCH;

typedef unsigned char UCHAR;
typedef unsigned char* PUCHAR;

typedef uint16_t wchar_t;
typedef wchar_t WCHAR;
typedef wchar_t* WCHAR;

typedef wchar_t UNICODE;

typedef uint16_t WORD;
typedef uint16_t* PWORD;
typedef uint16_t* LPWORD;

typedef int16_t SHORT;
typedef uint16_t USHORT;
typedef uint16_t* PUSHORT;

typedef int32_t BOOL;
typedef int32_t* PBOOL;
typedef int32_t* LPBOOL;

typedef uint32_t DWORD;
typedef uint32_t* PDWORD;
typedef uint32_t* LPDWORD;

typedef int32_t LONG;
typedef int32_t* PLONG;
typedef int32_t* LPLONG;
typedef int32_t LONG32;

typedef uint32_t ULONG;
typedef uint32_t* PULONG;
typedef uint32_t ULONG32;

typedef int64_t LONGLONG;
typedef int64_t LONG64;

typedef uint64_t ULONGLONG;
typedef uint64_t ULONG64;
typedef uint64_t DWORDLONG;
typedef uint64_t DWORD64;
typedef DWORDLONG* PDWORDLONG;
typedef ULONGLONG* PULONGLONG;

typedef uint8_t UINT8;
typedef uint16_t UINT16;
typedef uint32_t UINT32;
typedef uint64_t UINT64;

typedef uint32_t UINT;
typedef uint32_t* PUINT;
typedef uint32_t* LPUINT;

typedef int8_t INT8;
typedef int16_t INT16;
typedef int32_t INT32;
typedef int64_t INT64;

typedef int32_t INT;
typedef int32_t* PINT;
typedef int32_t* LPINT;

typedef WCHAR *PWCH;
typedef WCHAR *LPWCH;
typedef WCHAR *PWSTR;
typedef WCHAR *LPWSTR;
typedef const WCHAR *PCWSTR;
typedef const WCHAR *LPCWSTR;

typedef CHAR *PSTR;
typedef CHAR *LPSTR;
typedef const CHAR *LPCSTR;

typedef int32_t HRESULT;

struct HWND__;
typedef HWND__* HWND;

struct HKEY__;
typedef HKEY__* HKEY;
typedef HKEY* PHKEY;

struct HINSTANCE__;
typedef struct HINSTANCE__* HINSTANCE;
typedef HINSTANCE HMODULE;

struct _GUID {
	DWORD Data1;
	WORD  Data2;
	WORD  Data3;
	BYTE  Data4[8];
};
typedef _GUID GUID;
typedef GUID* LPGUID;
typedef const GUID* LPCGUID;


struct _FILETIME {
	DWORD dwLowDateTime;
	DWORD dwHighDateTime;
};
typedef _FILETIME FILETIME;
typedef _FILETIME* PFILETIME;
typedef _FILETIME* LPFILETIME;

struct LARGE_INTEGER {
	DWORD LowPart;
	LONG  HighPart;
};
typedef LARGE_INTEGER* PLARGE_INTEGER;

struct ULARGE_INTEGER {
	uint64_t QuadPart;
};
typedef ULARGE_INTEGER* PULARGE_INTEGER;

typedef void* PSID;
typedef void* PSECURITY_DESCRIPTOR;

struct _SECURITY_ATTRIBUTES {
	DWORD nLength;
	LPVOID lpSecurityDescriptor;
	BOOL bInheritHandle;
};
typedef _SECURITY_ATTRIBUTES SECURITY_ATTRIBUTES;
typedef _SECURITY_ATTRIBUTES* PSECURITY_ATTRIBUTES;
typedef _SECURITY_ATTRIBUTES* LPSECURITY_ATTRIBUTES;

typedef DWORD LCID;

struct tagRECT {
	LONG left;
	LONG top;
	LONG right;
	LONG bottom;
};
typedef tagRECT RECT;

struct tagPOINT {
	LONG x;
	LONG y;
};
typedef tagPOINT POINT;
typedef tagPOINT* PPOINT;
typedef tagPOINT* NPPOINT;
typedef tagPOINT* LPPOINT;

struct OVERLAPPED {
  ULONG_PTR Internal;
  ULONG_PTR InternalHigh;
	union {
		struct {
			DWORD Offset;
			DWORD OffsetHigh;
		} s;
		PVOID Pointer;
	} u;
  HANDLE    hEvent;
};
typedef OVERLAPPED* LPOVERLAPPED;
typedef void (__stdcall *LPOVERLAPPED_COMPLETION_ROUTINE)(DWORD dwErrorCode, DWORD dwNumberOfBytesTransferred, LPOVERLAPPED lpOverlapped);

void cexit() __noreturn;
void exit(int status) __noreturn;
void __stdcall ExitProcess(uint32_t exitCode) __noreturn;
void __stdcall ExitThread(uint32_t exitCode) __noreturn;
void __stdcall RaiseException(uint32_t exceptionCode, uint32_t flags, uint32_t argCount, size_t* args) __noreturn;
void __stdcall CxxThrowException(void* pExceptionObject, void* pThrowInfo) __noreturn;

void report_gsfailure(uint64_t stack_cookie) __noreturn;
void AfxThrowOleException(int sc) __noreturn;
void AfxThrowMemoryException() __noreturn;
void AfxThrowInvalidArgException() __noreturn;
void AfxThrowNotSupportedException() __noreturn;
void AfxThrowArchiveException(int cause, LPCTSTR lpszArchiveName) __noreturn;
void AfxThrowFileException(int cause, LONG lOsError, LPCTSTR lpszFileName) __noreturn;
void com_issue_error() __noreturn;
void __stdcall com_raise_error(HRESULT hr, IErrorInfo* perrinfo) __noreturn;
void terminate(void) __noreturn;
void unexpected(void) __noreturn;
void ExceptionPtrRethrow(const exception_ptr *ep) __noreturn;
void abort(void) __noreturn;
void RaiseException(uint32_t hr, uint32_t dwExceptionFlags) __noreturn;
